#ifndef _BASIC_H
#define _BASIC_H
/************************************************/
/*		definition of standard data types		*/
/************************************************/
#define __cdecl
 
#define	CHAR	char
#define	UCHAR	unsigned char
#define	SHORT	short
#define	USHORT	unsigned short
#define	BOOL	long
#define	LONG	long
#define	ULONG	unsigned long
#define	VOID	void

#define STATIC static
#define BOOLEAN BOOL
#define TRUE 	1	
#define FALSE 	0
typedef	CHAR	*PCHAR;
typedef	UCHAR	*PUCHAR;
typedef	SHORT	*PSHORT;
typedef	USHORT	*PUSHORT;
typedef	BOOL	*PBOOL;
typedef	LONG	*PLONG;
typedef	ULONG	*PULONG;
typedef	VOID	*PVOID;

#ifndef NULL
	#define NULL 0
#endif

/*
 try to .......
	for command complete status,buffer ready for read/write, the status will ok
	'immediately' after command set.
 
	if use interrupt, the interrupt happen may before we wait or in wait or after wait,
	it is an hard way determining this.
*/
/*
	refer to bookmark <after year>........
	for interrupt mode:
		ret = wait_event_interruptible
		ret = wait_event_interruptible_timeout
		if(ret==0)
		else if(....
		else....
		// add this condition ?
		if(waitqueue_active)
			wake_up_interruptible()

	for polling mode:
		while(1)
		{
			if(condition)
				....break;
			if(error)
				....break;
			if(signal_pending(current))
				....break;
			.......
			else
				....schedule();
				
		}
*/

#define ENABLE_WRITE_PROTECT
#define WAIT_CC_POLLING	// define this will wait for command complete using polling otherwise interrutp
#define WAIT_BR_POLLING	// define this will wait for buffer read ready using polling
#define WAIT_BW_POLLING

#define SDIO_TC_INTERRUPT	// define this will use transfer complete interrupt
#define SCSI_THREAD	// define this will handle scsi command using thread
#define SDIO_WRITE_MULTI	// define this will support write multi count block.
#define SDIO_READ_MULTI	// define this will support read multi count block.

#define SCATTER_GATHER	// define this will use the scatter-gather funciton when /read/write data to sd card.
//#define INSREM_CMD_THREAD // define this will create/kill scsi command thread when card insert/remove
//#define SCSI_UNREGISTER_QUICK // define this will unregister scsi module in interrupt handler
#endif
