/*
 * OZ711MS1 OZ711MP1 linux driver
 * O2Micro Inc.
 * toby.yang@o2micro.com
 * 2005/4/17
   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#ifndef _WINIF_H_
#define _WINIF_H_
#include "basic.h"
extern "C" unsigned long  mem_rDword(unsigned long* address);
extern "C"   unsigned short mem_rWord (unsigned short* address);
extern "C"  unsigned char  mem_rByte (unsigned char* address);
extern "C"  void           mem_wDword(unsigned long* address, unsigned long dwData);
extern "C" void           mem_wWord (unsigned short* address, unsigned short wData);
extern "C" void           mem_wByte (unsigned char* address, unsigned char bData);
extern "C"   void SysDelay(unsigned long Timeout );
extern "C"  void SysDelayMicroS(unsigned long Timeout );

extern "C"   void o2media_wait_event_interruptible(void);
extern "C"  void o2media_clear_intrflags(void);
extern "C"   BOOLEAN o2media_check_intrflags(void);
extern "C"   void o2media_set_intrflags(void);
extern "C"   void o2media_wait_timerint_event_interruptible(void);
extern "C"  void o2media_clear_timerint(void);
extern "C"   void o2media_set_timerint(void);
extern "C"   void o2media_complete_and_exit(void);
extern "C"  void o2media_wait_for_completion(void);
extern "C"   BOOLEAN winif_signal_pending_current(void);
extern "C"   int winif_kernel_thread(PVOID StartRoutine,PVOID StartContext);
extern "C"   void winif_kill_proc(int pid,int sig);
extern "C"   void winif_strncpy(char* to,const char* from,int length);
extern "C"   void winif_memcpy(void* to, void* from,int length);
extern "C" void  RtlZeroMemory(PVOID des,int length);
extern "C" void	RtlFillMemory(PVOID des,int length, int data);
extern "C" void RtlCopyMemory(UCHAR* to,UCHAR* from,int length);
extern "C"  void o2media_scsi_register(unsigned long devext_addr);
extern "C"   void o2media_scsi_unregister(void);
extern "C"   void o2media_scsicallback(void);
extern "C" void* ExAllocatePool(BOOLEAN f_atomic,unsigned long size);
extern "C" void ExFreePool(PVOID ptr,unsigned long size);
extern "C" int printk(const char *fmt, ...);
#endif                                    
